/*
 *	main.c
 *
 *	OGG Player (s)
 *
 *	* Sun Sep 14 22:42:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _OGGINFO {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} OGGINFO;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

OGGINFO ogg_info[MAXDIR];		/* OGGt@CXg */
int ogg_count;				/* OGGt@C̐   */
int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */
int curplay = -1;			/* Đt@CCfNX */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void run();
int  ogg_play(const char* fname);
void ogg_stop();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
ogg_info_compare(const void* _a, const void* _b)
{
	OGGINFO* a = (OGGINFO*)_a;
	OGGINFO* b = (OGGINFO*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	OGGINFO* mi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* OGGt@CT܂B */
	memset(ogg_info, 0, sizeof ogg_info);
	ogg_count = 0;
	mi = &ogg_info[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(ogg_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".ogg"łȂ΁A΂܂B */
		len = strlen(fi.filename);
		if(len < 4) continue;
		if(strcasecmp(&fi.filename[len - 4], ".ogg") != 0) continue;
		/* t@CƃTCYi[܂B */
		if(len > MAXFILENAME) DIE();
		memcpy(mi->fname, fi.filename, len);
		mi->size = fi.length;
		ogg_count++;
		mi++;
	}
	pceFileFindClose(&fi);
	if(ogg_count == 0) {
		err_disp("OGGt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(ogg_info, ogg_count, sizeof(OGGINFO), ogg_info_compare);

	/* S48MHz[hB */
	turbo(1);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	run
 ****************************************************************************/

void
run()
{
	int retval, i, y, c, i_ogg;
	OGGINFO* mi;

	goto L10; /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(joy & TRG_UP && cursel > 0             ) cursel--;
		if(joy & TRG_DN && cursel < ogg_count - 1) cursel++;
		if(joy & TRG_LF) {
			cursel -= MAX_DISP;
			if(cursel < 0) cursel = 0;
		}
		if(joy & TRG_RI) {
			cursel += MAX_DISP;
			if(cursel > ogg_count - 1) cursel = ogg_count - 1;
		}
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* ĐJnH */
		if(joy & TRG_A) {
			ogg_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			mi = &ogg_info[cursel];
			retval = ogg_play(mi->fname);
			if(retval == 0) {
				curplay = cursel;
			} else {
				err_disp("Đł܂ł");
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			ogg_stop();
			curplay = -1;
		}

L10:
		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		mi = &ogg_info[curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_ogg = curtop + i;
			if(i_ogg > ogg_count - 1) break;
			if(i_ogg == cursel) {
				if(i_ogg == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i_ogg == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			render_string(&render, 4 + 4 *  1, y, mi->fname, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", mi->size);
			mi++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"=========== OGG Player ===========",
			0x82, 0);

		/* ʓ]B */
		draw = 1;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void*
my_malloc(size_t s)
{
	void* p = malloc(s);
	if(!p) DIE();
	return p;
}

void*
my_calloc(size_t s1, size_t s2)
{
	void* p = calloc(s1, s2);
	if(!p) DIE();
	return p;
}

void*
my_realloc(void* p, size_t s)
{
	p = realloc(p, s);
	if(!p) DIE();
	return p;
}

void
my_free(void* p)
{
	free(p);
}

/****************************************************************************
 *	
 ****************************************************************************/

#define OGGBUFLEN 320	/* =16000/50c1[tick](=1/50[sec])̃Tv */

int playing;
OggVorbis_File vf;

static int
ogg_stream_callback(short* wbuff, int param)
{
	OggVorbis_File* vf = (OggVorbis_File*)param;
	int retval;

	/*{{Œ̃nOAbv*/
	if(pcePadGetDirect() & (PAD_B | PAD_SELECT)) return -1;
	/*}}Œ̃nOAbv*/

	retval = ov_read(vf, wbuff, OGGBUFLEN * sizeof(short), NULL);
	if(!retval) return -1; /* EOF */

	return 0;
}

int
ogg_play(const char* fname)
{
	int retval;
	FILE* fp;
	short wbuff[OGGBUFLEN];

	/* ܂mɒ~܂B */
	ogg_stop();

	/* OGGt@CJ܂B */
	fp = fopen(fname, "rb");
	if(!fp) return -1;

	/* fR[_܂B */
	retval = ov_open(fp, &vf, NULL, 0);
	if(retval < 0) {
		fclose(fp);
		return -1;
	}

	/* Đ}[NB */
	playing = 1;

	/* ŏ̃fR[hɎԂ悤Ȃ̂ŁA荞݂̊OōsĂB */
	ov_read(&vf, wbuff, OGGBUFLEN * sizeof(short), NULL);

	/* Xg[ĐJnB */
	stream_play(OGGBUFLEN, ogg_stream_callback, (int)&vf);

	return 0;
}

void
ogg_stop()
{
	/* Xg[Đ~܂B */
	stream_stop();

	if(playing) {
		ov_clear(&vf); /* ̒fclose()Ă΂܂ */
		playing = 0;

		/* Tremor[NĂ(?)݂Ȃ̂ŁA~ނ𓾂q[vď܂B */
		ansi_InitMalloc((int)ansi_ucStartAlloc, (int)ansi_ucEndAlloc);
	}
}

